const pool  = require("../Utils/db");
const tableNames = require("../Utils/allTableNames");

const cronDataCenterline = (item, newid, currentDate) => {
    pool.getConnection((err, connection) => {
        if (err) {
            console.log("eror while connection", err);
        } else {
            const insertQuery = `INSERT INTO ${tableNames.feedback} SET ?`;
            connection.query(insertQuery, item, (insertError, insertResults) => {
                if (insertError) {
                    console.error('Error inserting record:', insertError);
                    return;
                }
                console.log('Centerline Record Cron Successfully ==>:', item);
            });
            const updateQuery= `update ${tableNames.centerline} set dateToUpdate = ? where id = ?;`;
            connection.query(updateQuery, [item.dateToUpdate, newid], (updateError, updateResults) => {
                if (updateError) {
                    console.error('Error inserting record:', insertError);
                    return;}
                console.log('Centerline Record Cron Update Successfully ==>:', item);
            });
            const currentlyActiveQuery = `update ${tableNames.feedback} set currentlyActive = 0 where date < ? and frequency = ?;`;
            connection.query(currentlyActiveQuery, [currentDate,item.frequency], (insertError, insertResults) => {
                if (insertError) {
                    console.error('Error inserting record:', insertError);
                    return;
                }
                // console.log('Centerline Record Cron Successfully:', item);
            });
        }
        connection.release();
    });
};

module.exports = cronDataCenterline;


// const pool = require("../Utils/db");
// const tableNames = require("../Utils/allTableNames");

// const cronData = async (item, newid, currentDate) => {
//   try {
//     const connection = await pool.getConnection();

//     // Insert Query
//     const insertQuery = `INSERT INTO ${tableNames.feedback} SET ?`;
//     const insertResult = await connection.query(insertQuery, item);

//     console.log('Centerline Record Cron Successfully Inserted:', insertResult);

//     // Update Query
//     const updateQuery = `UPDATE ${tableNames.centerline} SET dateToUpdate = ? WHERE id = ?`;
//     const updateResult = await connection.query(updateQuery, [item.dateToUpdate, newid]);

//     console.log('Centerline Record Cron Successfully Updated:', updateResult);

//     // Currently Active Update
//     const currentlyActiveQuery = `UPDATE ${tableNames.feedback} SET currentlyActive = 0 WHERE date < ? AND frequency = ?`;
//     await connection.query(currentlyActiveQuery, [currentDate, item.frequency]);

//   } catch (error) {
//     console.error('Error:', error);
//   } finally {
//     connection.release();
//   }
// };

// module.exports = cronData;

