const pool = require("../Utils/db");
const tableNames = require("../Utils/allTableNames");
const moment = require('moment-timezone');
const poolFl = require("../Utils/dbFl");

const cronJobTimeout =  async (req, res) => {

    try {

        console.log("Timeout Cron Job Started");
        const currentDate = moment();
        const karachiTime = moment().tz('Asia/Karachi');
        const currentTime = karachiTime.format('HH:mm');
        const currentTimeArray = currentTime.split(":");
        const currentHour = currentTimeArray[0];
        // const currentHour = "11";
        console.log("Cuurent Hour: ", currentHour);
        let frequency, timeOut, timeOutArray, timeOutHour, differenceOfDays;

        const dayOfWeek = karachiTime.format('dddd');
        if (dayOfWeek !== "Sunday") {
            console.log("Today is not Sunday");
            pool.getConnection((error, connection) => {
                if (error) {
                    console.log("Error while connection (Cron Job Timeout): ", error.message);
                } else {
                    // connection.query(`SELECT * FROM ${tableNames.feedback} where userStatus = 0 AND frequency IN (${frequencyTimeOut})`, (err, result) => {
                    connection.query(`SELECT * FROM ${tableNames.feedback} where userStatus = 0 `, (error, result) => {
                        // connection.release();
                        if (error) {
                            console.log("Error while Getting Data (Cron Job Timeout): ", error.message);
                        } else {
                            // console.log("Result: ", result); 
                            if (result.length > 0) {
                                result.forEach(item => {
                                    console.log("Item: ", item);
                                    frequency = item.frequency;
                                    console.log(frequency);
                                    poolFl.getConnection((err, con) => {
                                        if (err) {
                                            console.log("Error while connection FL (Cron Job Timeout): ", err.message);
                                        } else {
                                            con.query(`SELECT timeOut from ${tableNames.frequencyFL} WHERE frequency = ?`, frequency, (err, res) => {
                                                con.release();
                                                if (err) {
                                                    console.log("Error while Getting Data (Cron Job Timeout): ", err.message);
                                                } else {
                                                    console.log("FL Result: ", res);
                                                    timeOut = res[0].timeOut;
                                                    console.log("timeOut", timeOut);
                                                    // timeOutHout = timeOut.split(":").[0];
                                                    timeOutArray = timeOut.split(":");
                                                    timeOutHour = timeOutArray[0];
                                                    // console.log("timeOutHour", timeOutHour);
                                                    if (currentHour === timeOutHour) {
                                                        differenceOfDays = currentDate.diff(item.date, 'days');
                                                        console.log("Difference Of Days", differenceOfDays);
                                                        if (differenceOfDays != 0) {
                                                            console.log("Time Out");
                                                            connection.query(`UPDATE ${tableNames.feedback} SET userStatus = 2 WHERE id = ?`, item.id, (err, result) => {
                                                                connection.release();
                                                                if (err) {
                                                                    console.log("Error while Updating Data (Cron Job Timeout): ", err.message);
                                                                } else {
                                                                    console.log("Result: ", result); 
                                                                }
                                                            });
                                                        }
                                                        else {
                                                            console.log("Time not Out");
                                                        }
                                                    } else {
                                                        console.log("Time Out not Matched based on Frequency");
                                                    }
                                                }
                                            });
                                        }
                                    });
                                });
                            } else {
                                console.log('No records found');
                            }
                        }
                    });
                    connection.release();
                }
            });    
        } else {
            console.log("Today is Sunday");
        }
        console.log("Timeout Cron Job Completed");
    } catch (err) {
    console.log("Cron Job Timeout (Catch): ", err.message);
    // return res.send(response(false, "Cron Job (Catch)", err.message));
    }
};

module.exports = { cronJobTimeout };



// const pool = require("../Utils/db");
// const tableNames = require("../Utils/allTableNames");
// const moment = require('moment-timezone');
// const poolFl = require("../Utils/dbFl");

// const cloneRecordTimeout =  async (req, res) => {

//     const currentDate = moment();
//     const karachiTime = moment().tz('Asia/Karachi');
//     const currentTime = karachiTime.format('HH:mm');

// //  const getFrequencyTime = () => {
// //         return new Promise((resolve, reject) => {
// //             poolFl.getConnection((err, flconnection) => {
// //                 if (err) {
// //                     reject(err);
// //                 } else {
// //                     flconnection.query(
// //                         `SELECT * FROM frequency WHERE ? >= STR_TO_DATE(shiftTime, '%H:%i') AND ? < STR_TO_DATE(shiftTimeEnd, '%H:%i')`,
// //                         [currentTime, currentTime],
// //                         (err, result) => {
// //                             flconnection.release();
// //                             if (err) {
// //                                 reject(err);
// //                             } else {
// //                                 resolve(result);
// //                             }
// //                         }
// //                     );
// //                 }
// //             });
// //         });
// //     };  


//     try {
        
//         console.log("Timeout Cron Job Started");
//         // const frequencyTimeResult = await getFrequencyTime();
//         console.log("Frequency Time Result:", frequencyTimeResult);

//         const shiftTimes = frequencyTimeResult.map(item => item.shiftTime);
//         console.log("Shift Times:", shiftTimes);
//         const shiftFrequency = frequencyTimeResult.map(item => item.frequency);
//         console.log("Shift Times:", shiftFrequency);

//         const frequencyList = shiftFrequency.map(freq => `'${freq}'`).join(',');
//         console.log(frequencyList)

//        const timeOut = shiftTimes.find((item) => currentTime === item)
//        console.log(timeOut)

//           // Find the record where shiftTime matches currentTime
//           const frequencyTimeOut = frequencyTimeResult.find(item => item.shiftTime === currentTime);
//           const frequency = frequencyTimeOut ? frequencyTimeOut.frequency : null;
//           console.log("Frequency:", frequency);

//         if (currentTime === "22:45" ) {
//             console.log("in condition")

//             pool.getConnection((err, connection) => {
//                 if (err) {
//                     console.log("Error while connection (Cron Job Timeout): ", err.message);
//                 }
//                 // connection.query(`SELECT * FROM ${tableNames.feedback} where userStatus = 0 AND frequency IN (${frequencyTimeOut})`, (err, result) => {
//                 connection.query(`SELECT * FROM ${tableNames.feedback} where userStatus = 0 `, (err, result) => {

//                     connection.release();
//                     if (err) {
//                         console.log("Error while Getting Data (Cron Job Timeout): ", err.message);
//                     } else {
//                         // console.log("Result: ", result); 
//                         if (result.length > 0) {
//                             result.forEach(item => {
//                                 const differenceOfDays = currentDate.diff(item.date, 'days');
//                                 // console.log("Difference Of Days", differenceOfDays);
//                                 if (differenceOfDays != 0) {
//                                     console.log("Time Out");
//                                     connection.query(`UPDATE ${tableNames.feedback} SET userStatus = 2 WHERE id = ?`, item.id, (err, result) => {
//                                         connection.release();
//                                         if (err) {
//                                             console.log("Error while Updating Data (Cron Job Timeout): ", err.message);
//                                         } else {
//                                             // console.log("Result: ", result); 
//                                         }
//                                     });
//                                   }
//                                   else {
//                                     console.log("Time not Out");
//                                   }
//                             });
//                         } else {
//                             console.log('No records found');
//                         }
//                     }
//                 }
//             );
//             });
//         } 
//         console.log("Timeout Cron Job Completed");
//         } catch (err) {
//         console.log("Cron Job Timeout (Catch): ", err.message);
//         // return res.send(response(false, "Cron Job (Catch)", err.message));
//         }
// };

// module.exports = { cloneRecordTimeout };






// //Rafay

// // const pool = require("../Utils/db");
// // const tableNames = require("../Utils/allTableNames");
// // const moment = require('moment-timezone');
// // const poolFl = require("../Utils/dbFl");

// // const cloneRecordTimeout =  async (req, res) => {

// //     const currentDate = moment();
// //     const karachiTime = moment().tz('Asia/Karachi');
// //     // console.log(karachiTime);
// //     // Separate the date and time
// //     // const currentDate = karachiTime.format('YYYY-MM-DD');
// //     const currentTime = karachiTime.format('HH:mm');

// //  const getFrequencyTime = () => {
// //         return new Promise((resolve, reject) => {
// //             poolFl.getConnection((err, flconnection) => {
// //                 if (err) {
// //                     reject(err);
// //                 } else {
// //                     flconnection.query(
// //                         //`SELECT * FROM frequency WHERE ? >= STR_TO_DATE(shiftTime, '%H:%i') AND ? < STR_TO_DATE(shiftTimeEnd, '%H:%i')`,
// //                         //[currentTime, currentTime],
// //                         `SELECT * FROM frequency WHERE ? = STR_TO_DATE(timeOut, '%H:%i')`,[currentTime],
// //                         (err, result) => {
// //                             flconnection.release();
// //                             if (err) {
// //                                 reject(err);
// //                             } else {
// //                                 resolve(result);
// //                             }
// //                         }
// //                     );
// //                 }
// //             });
// //         });
// //     };  


// //     try {
        
// //         console.log("Timeout Cron Job Started");
// //         const frequencyTimeResult = await getFrequencyTime();
// //         console.log("Frequency Time Result:", frequencyTimeResult);

// //         const outTimes = frequencyTimeResult.map(item => item.timeOut);
// //         console.log("Shift Times:", outTimes);
// //         const shiftFrequency = frequencyTimeResult.map(item => item.frequency);
// //         console.log("Shift Times:", shiftFrequency);

// //         const frequencyList = shiftFrequency.map(freq => `'${freq}'`).join(',');
// //         console.log(frequencyList)

// //        const timeOut = outTimes[0]//shiftTimes.find((item) => currentTime === item)
// //        console.log(timeOut)

// //         if (currentTime === timeOut ) {
// //             console.log("in condition")

// //             pool.getConnection((err, connection) => {
// //                 if (err) {
// //                     console.log("Error while connection (Cron Job Timeout): ", err.message);
// //                 }
// //                 connection.query(`SELECT * FROM ${tableNames.feedback} where userStatus = 0 AND frequency IN (${frequencyList})`, (err, result) => {
// //                     connection.release();
// //                     if (err) {
// //                         console.log("Error while Getting Data (Cron Job Timeout): ", err.message);
// //                     } else {
// //                         // console.log("Result: ", result); 
// //                         if (result.length > 0) {
// //                             result.forEach(item => {
// //                                 const differenceOfDays = currentDate.diff(item.date, 'days');
// //                                 // console.log("Difference Of Days", differenceOfDays);
// //                                 if (differenceOfDays != 0) {
// //                                     //console.log("Time Out");
// //                                     connection.query(`UPDATE ${tableNames.feedback} SET userStatus = 2 WHERE id = ?`, item.id, (err, result) => {
// //                                         connection.release();
// //                                         if (err) {
// //                                             console.log("Error while Updating Data (Cron Job Timeout): ", err.message);
// //                                         } else {
// //                                             // console.log("Result: ", result); 
// //                                         }
// //                                     });
// //                                   }
// //                                   else {
// //                                     console.log("Time not Out");
// //                                   }
// //                             });
// //                         } else {
// //                             console.log('No records found');
// //                         }
// //                     }
// //                 }
// //             );
// //             });
// //         } 
// //         console.log("Timeout Cron Job Completed");
// //         } catch (err) {
// //         console.log("Cron Job Timeout (Catch): ", err.message);
// //         // return res.send(response(false, "Cron Job (Catch)", err.message));
// //         }
// // };

// module.exports = { cloneRecordTimeout };


