const jwt = require("jsonwebtoken");
const RESPONSE = require("../GlobalResponse/RESPONSE");
const tableNames = require("../Utils/allTableNames");
const pool = require("../Utils/db");

module.exports = async (req, res, next) => {
  let token = req.get("Authorization");

  if (!token) {
    const err = new Error("Not Authenticated");
    err.statusCode = 401;
    err.message = "User Not Authenticated";
    return res.status(401).json({
      message: err.message,
    });
  }
  token = token.split(" ")[1];
  // //console.log("token >>", token);

  let decodedToken = "";
  try {
    decodedToken = jwt.decode(token);
    // let decodeToken = jwt.decode(token);
  } catch (err) {
    err.statusCode = 401;
    err.message = "login token not verified";
    res.status(401).json({
      message: err.message,
    });
    throw err.message;
  }

  if (!decodedToken) {
    const err = new Error("Not Authenticated");
    err.statusCode = 401;
    err.message = "User Not Authenticated";
    res.status(401).json({
      message: err.message,
    });
    throw err.message;
  } else {
    // //console.log("decodedToken >>>", decodedToken);

    pool.getConnection((err, connection) => {
      if (err) {
        res.status(500).send(RESPONSE("database error", {}));
        throw err;
      }
      connection.query(
        `SELECT * FROM ${tableNames.users} where id=${decodedToken.id}`,
        (err, result) => {
          connection.release();
          if (err) {
            return res.status(400).send(RESPONSE("error while select", {}));
          } else {
            // //console.log("result >>", result);
            if (result.length > 0) {
              // req.userId = decodedToken.id;
              // //console.log("req.userId >>", req.userId);
              //console.log("next >>");
              next();
            } else {
              const err = new Error("Not Authenticated");
              err.statusCode = 401;
              err.message = "User Not Authenticated";
              res.status(401).json({
                message: err.message,
              });
            }
          }
        }
      );
    });
  }
};
